import Head from 'next/head'
import Image from 'next/image'
import styles from '../styles/Home.module.css'
import Link from 'next/link'
import { useEffect, useState } from 'react';




export const getStaticProps = async () => {
  const res = await fetch("https://restcountries.com/v3.1/all");
  const d = await res.json();


  return {
    props: {
      d,

    },
  };
};
export default function Home({ d }) {

  const [data, setData] = useState(d);

  const search = async (event) => {
    event.preventDefault();

    let query1 = event.target[0].value;

    const res = await fetch("https://restcountries.com/v3.1/name/" + query1);
    let data1 = await res.json();

    setData(data1);
  }


// export default function Home({ d }) {

//   const [data, setData] = useState(d);

//   const search = async (event) => {
//     event.preventDefault();

//     let query1 = event.target[0].value;
//     if (query1 == "") {
//       const res = await fetch("https://restcountries.com/v3.1/all");
//       let data1 = await res.json();
//      // console.log(query1);

//       setData(data1);
  //   } 
  //   else {
  //   //  try{
  //     const res = await fetch("https://restcountries.com/v3.1/name/" + query1);
  //     let data1 = await res.json();
  //    // console.log(query1);
  //    if(res != undefined)
  //     setData(data1);
      
     
    
  //  // }
  //   else{
  //     // const res = await fetch("https://restcountries.com/v3.1/name/" + query1);
  //     // let data1 = await res.json();
  //       reactDom.render((
  //         <Player
  //           autoplay
  //           loop
  //           src="https://assets3.lottiefiles.com/packages/lf20_XZ3pkn.json"
  //           style={{ height: '200px', width: '300px' }}
  //         >
  //           <Controls visible={false} />
  //       </Player>
  //       ), res);
  //      // alert("put the value");
  //     // setData(data1);
  //     }
      
     
      
     
  //   }
  // }

  function dateTime(timezone) {
    let offset1 = timezone.split("C");
    let offset2 = offset1[1].split(":");
    let offset3 = parseInt(offset2[0]);
    let offset4 = parseInt(offset2[1]);
    let offset = offset3 + (offset4 / 60);
    let x = new Date();
    let month = x.getMonth();
    let months = ["Jan", "Feb", "Mar", "Apr", "May", "Jun",
      "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
    let day = x.getDate();
    let year = x.getFullYear();
    let str1 = ""
    let str = ""
    let str2 = ""
    str1 = day + " " + months[month] + " " + year;
    let localTime = x.getTime();
    let localOffset = x.getTimezoneOffset() * 60000;
    let utc = localTime + localOffset;
    let nd = new Date(utc + (3600000 * offset));
    let h = nd.getHours();
    let m = nd.getMinutes();
    let h1 = "";
    let m1 = "";
    if (h < 10) {
      h1 = h1 + "0" + h.toString();
    }
    if (m < 10) {
      m1 = m1 + "0" + m.toString();
    }
    if (h < 10) {
      if (m < 10) {
        str2 = h1 + ":" + m1;
      }
      else {
        str2 = h1 + ":" + m;
      }
    }
    else {
      if (m < 10) {
        str2 = h + ":" + m1;
      }
      else {
        str2 = h + ":" + m;
      }
    }
    str = str1 + " and " + str2;

    return (str)
  }

  return (
    <div className={styles.container}>
      <Head>
        <title>Countries App</title>
        <meta name="description" content="Generated by create next app" />
       
        <link rel="icon" href="favicon.ico" />

        <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta1/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-giJF6kkoqNQ00vy+HMDP7azOuL0xtbfIcaT9wjKHr8RbDVddVHyTfAAsrekwKmP1" crossorigin="anonymous" />
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta1/dist/js/bootstrap.bundle.min.js" integrity="sha384-ygbV9kiqUc6oa4msXn9868pTtWMgiQaeYH7/t7LECLbyPA2x65Kgf80OJFdroafW" crossorigin="anonymous"></script>

     
      </Head>
      <div className={styles.box1+" "+styles.center}  style={{'border':'none','padding':'10px 0px'}}>
        <h1 style={{'textAlign':'left'}}>
          Countries
        </h1>
        <div className={styles.ab}>
          <form method='POST' action="/" onSubmit={search}>
            <div className="input-group mb-3">
              <input type="text" style={{'borderRight':'0', 'borderRadius':'0' }} className="form-control" placeholder="Search countries" required id="input" />
              <div className="input-group-append">
                <button className="input-group-text" style={{ 'background':'white', 'borderLeft':'0', 'borderRadius':'0' }} id="search">
                  <img src="https://pngimage.net/wp-content/uploads/2018/06/searchicon.png-3.png" height="25px"/>
                </button>
              </div>
            </div>
          </form>
        </div>

      </div>
      { 
       data[0]
         && data.slice(0, 250).map((element) => {
          let curr = "NULL";
          if (element.currencies) {
            curr = Object.values(element.currencies)[0].name;
          }
          return <div key={element.cca3}>
            <div className={styles.box1 + " mb-3"}>
              <div className="row">
                <div className="col-4">
                  <img src={element.flags.png} width="100%" height="90%" />
                </div>
                <div className="col">
                  <h2>{element.name.common}</h2>
                  <p className="m-0">Currency : {curr}</p>
                  <p className="m-0 mb-1">Current date and time :{dateTime(element.timezones[0])} </p>
                  <a className='btn btn-outline-primary' style={{ 'width': '48%' }} href={element.maps.googleMaps}>Show Map</a>
                  <Link href={"/detail/" + element.cca3}><a className='btn btn-outline-primary' style={{ 'width': '48%', 'marginLeft': '10px' }}>Detail</a></Link>
                </div>
              </div>
            </div>
          </div>

        })
      }
    </div>
  )
}

